//////////////////////////////////////////////////////////////////////
//
// alphabet.cpp
//
// alphabet class
//
//
//                                                    XIII
//////////////////////////////////////////////////////////////////////

#ifndef _ALPHABET_CPP_
#define _ALPHABET_CPP_

#include "alphabet.h"
#include "lib.h"

ALPHABET::ALPHABET():
alphabet(NULL)
{

}

ALPHABET::ALPHABET(char *_alphabet)
{
	set_alphabet(_alphabet);
}

ALPHABET::ALPHABET(const ALPHABET &rhs)
{	
	//
	// Copy Constructor
	//
	if(this==&rhs)
		return;

	alphabet=NULL;
	set_alphabet(rhs.get_alphabet());
}

ALPHABET::~ALPHABET()
{
	if(alphabet)
	{
		delete [] alphabet;
		alphabet=NULL;
	}
}

void ALPHABET::set_alphabet(char* _alphabet)
{
	if(_alphabet)
	{
		int len = strlen(_alphabet);
		if(alphabet)
		{
			delete [] alphabet;
			alphabet=NULL;
		}
		alphabet = new char [len+1];
		if(!alphabet)
		{
			prerr("Cant allocate memory for alphabet");
			return;
		}
		ZeroMemory(alphabet,len+1);
		strcpy(alphabet,_alphabet);
	}
}

char* ALPHABET::get_alphabet() const
{
	return alphabet;
}

int ALPHABET::length() const
{
	return strlen(alphabet);
}

char ALPHABET::get_next_symbol(char _symbol)
{
	//
	// return next symbol from alphbet
	// if error occured return 0
	// if this is last symbol in alphabet return 1
	//
	int i;
	int ilen=length();
	int ilen2=ilen-1;
	if(!alphabet)
	{
		prerr("define alphabet first!");
		return 0;
	}

	for(i=0;i<ilen;i++)
	{
		if(alphabet[i]==_symbol)
		{
			if(i!=ilen2)
				return alphabet[i+1];
			else
				return 1;
		}
	}

	prerr("Here now such symbol[%c] in Alphabet!",_symbol);

	return 0;
}

#endif // #ifndef _ALPHABET_CPP_
