//////////////////////////////////////////////////////////////////////
//
// client.h
//
// client class
//
//
//                                                    XIII
//////////////////////////////////////////////////////////////////////

#ifndef _CLIENT_H_
#define _CLIENT_H_

#include <windows.h>

#include "definition.h"
#include "alphabet.h"
#include "filefunc.h"

class CLIENT
{
public:
	CLIENT();
	CLIENT(char *_IP);
	CLIENT(const CLIENT &rhs); // Copy Constructor
	~CLIENT();
	void set_IP(char* _IP);
	char* get_IP() const;
	void set_alphabet(char* _alphabet);
	char* get_alphabet() const;
	void set_hash(char* _hash);
	char* get_hash() const;
	void set_hash_type(int _hash_type);
	int get_hash_type() const;
	void set_password(char* _password);
	char* get_password() const;
	void set_border(char* _border);
	char* get_border() const;
	void set_state(STATE _state);
	STATE get_state() const;
	void set_borderstate(BORDERSTATE _borderstate);
	BORDERSTATE get_borderstate() const;
	void crack();
	bool normalize_hash();
private:
	char *IP;
	ALPHABET alphabet;
	char *hash;
	int hash_type;
	char* password;
	char* border;
	STATE state;
	BORDERSTATE borderstate;
	int bruteforce();
	int check_password(int _passlength);
	int check_border(int _passlength,int _borderlength);
};

typedef class CLIENT client;

#endif // #ifndef _CLIENT_H_
