//////////////////////////////////////////////////////////////////////
//
// filefunc.cpp
//
// for file-work functions
//
//
//                                                    XIII
//////////////////////////////////////////////////////////////////////

#ifndef _FILEFUNC_CPP_
#define _FILEFUNC_CPP_

#include "filefunc.h"
#include "lib.h"


void writelog(char* buf1,char* buf2, int event)
{
	//
	// write log-file
	// if event != 0 then delete log-file
	//
#ifdef LOG
	char fpath[MAX_PATH], flog[20];
	ZeroMemory(fpath, MAX_PATH);
	ZeroMemory(flog, 20);

	// for get system time
	SYSTEMTIME SysTime;
	char time[256];
	ZeroMemory(time, 256);
	int itemp;

	HANDLE hFile;

	lstrcat(flog, LOG_FILE_NAME);

	if(event)
	{
		//
		// delete log-file
		//
		DeleteFile(fpath);
		return;
	}
	

//	GetTempPath(sizeof(fpath), fpath);
	lstrcat(fpath, ".\\");
	lstrcat(fpath, flog);

	unsigned long int iwrited;

	hFile=CreateFile(fpath,GENERIC_WRITE,FILE_SHARE_READ|FILE_SHARE_WRITE,NULL,OPEN_ALWAYS,FILE_ATTRIBUTE_ARCHIVE,NULL);

	SetFilePointer(hFile,0,0,FILE_END);

	GetLocalTime(&SysTime);
	itemp=wsprintf(time,"[%02.2d.%02.2d %02.2d:%02.2d] \t",SysTime.wDay,SysTime.wMonth,SysTime.wHour,SysTime.wMinute);
	WriteFile(hFile,time,itemp,&iwrited,NULL);

	WriteFile(hFile,buf1,lstrlen(buf1),&iwrited,NULL);
	WriteFile(hFile,"\t\t\t\t",4,&iwrited,NULL);
	WriteFile(hFile,buf2,lstrlen(buf2),&iwrited,NULL);
	WriteFile(hFile,"\r\n",2,&iwrited,NULL);

# ifdef DEBUG
	FlushFileBuffers(hFile);
# endif // #ifdef DEBUG

	CloseHandle(hFile);
#endif //#ifdef LOG
}

void writehash(char* pass, char* hash)
{
	//
	// write pass\thash into file
	//
#ifdef HASHLOG
	char fpath[MAX_PATH], flog[20];
	ZeroMemory(fpath, MAX_PATH);
	ZeroMemory(flog, 20);

	HANDLE hFile;
	strcat(flog, HASHLOG_FILE_NAME);


//	GetTempPath(sizeof(fpath), fpath);
# ifdef WIN32
	strcat(fpath, ".\\");
# else
	strcat(fpath, "./");
# endif //#ifdef WIN32
	strcat(fpath, flog);

	unsigned long int iwrited;

	hFile=CreateFile(fpath,GENERIC_WRITE,FILE_SHARE_READ|FILE_SHARE_WRITE,NULL,OPEN_ALWAYS,FILE_ATTRIBUTE_ARCHIVE,NULL);

	SetFilePointer(hFile,0,0,FILE_END);

	WriteFile(hFile,pass,strlen(pass),&iwrited,NULL);
	WriteFile(hFile,"\t",1,&iwrited,NULL);
	WriteFile(hFile,hash,strlen(hash),&iwrited,NULL);
	WriteFile(hFile,"\n",1,&iwrited,NULL);

	CloseHandle(hFile);
#endif //#ifdef HASHLOG
}

#endif // #ifndef _FILEFUNC_CPP_
