//////////////////////////////////////////////////////////////////////
//
// sq_util.cpp
//
// for 
//
//
//                                                    XIII
//////////////////////////////////////////////////////////////////////

#ifndef _SQ_UTIL_CPP_
#define _SQ_UTIL_CPP_

#include "sq_util.h"

#include "lib.h"
#include "alphabet.h"

extern bool victory;

extern int pass_length;
extern int border_step;
extern ALPHABET alphabet;

bool next_border(char *cur_border)
{
	//
	// get next border, put it into cur_border and return true
	// if any error occured return false;
	//
	if(!cur_border)
	{
		prerr("undefined current border in next_border()");
		return false;
	}
	if(border_step<=0)
	{
		prerr("bad border_step in next_border()");
		return false;
	}
	if(pass_length<=0)
	{
		prerr("bad pass_length in next_border()");
		return false;
	}
	int blen=strlen(cur_border);
	char *ctemp=NULL;
	int i,j,k;
	char ct;

	if(blen<border_step)
	{
		ctemp=new char [border_step+1];
		if(!ctemp)
		{
			prerr("cant allocate memory for border in next_border()");
			return false;
		}
		ZeroMemory(ctemp, border_step+1);
		for(i=0;i<border_step-blen;i++)
			ctemp[i]=(alphabet.get_alphabet())[0];
		strcat(ctemp,cur_border);
		ZeroMemory(cur_border, blen);
		strcat(cur_border,ctemp);
		delete [] ctemp;
		return true;
	}


	j=blen-border_step;
	i=j;
	do
	{
		i=j;
		if(j>=0)
		{
			ct=alphabet.get_next_symbol(cur_border[j]);
			if( ct!=1)
			{
				cur_border[j]=ct;
				return true;
			}
			else
			{
				cur_border[j]=(alphabet.get_alphabet())[0];
				
				while(i>0)
				{
					i--;
					ct=alphabet.get_next_symbol(cur_border[i]);
					if(ct!=1)
					{
						cur_border[i]=ct;
						return true;
					}
					else
					{
						cur_border[i]=(alphabet.get_alphabet())[0];
						if(i==0)
							goto check;
						else
							continue;
					}
				}	
			}
		}
	}
	while(i>0);

check:
	if(pass_length>blen)
	{
		char* st=new char[blen+2];
		if(!st)
		{
			prerr("cant allocate memory for password in next_border()");
			return false;
		}
		ZeroMemory(st,blen+2);
		strcat(st," ");
		strcat(st,cur_border);
		st[0]=(alphabet.get_alphabet())[0];
		ZeroMemory(cur_border,blen);
		strcat(cur_border,st);
		delete []st;
		st=NULL;
		return true;
	}
	else
	{
		j=alphabet.length()-1;
		//
		// check LAST BORDER for avoid infinity :-)
		//
		k=0;
		for(i=blen-border_step+1;i<pass_length;i++)
		{
			if( cur_border[i]==(alphabet.get_alphabet())[j] )
				k++;
		}
		if( k==(pass_length-border_step+1) )
		{
			ZeroMemory(cur_border,blen);
			strcat(cur_border,"");
			return true;
		}
		//
		// last border :)
		//
		for(i=0;i<pass_length;i++)
			cur_border[i]=(alphabet.get_alphabet())[j];
		return true;
	}
}

#endif // #ifndef _SQ_UTIL_CPP_