//////////////////////////////////////////////////////////////////////
//
// squirrel.cpp
//
// for distributed hash cracking
//
//
//                                                    XIII
//////////////////////////////////////////////////////////////////////

#ifndef _SQUIRREL_CPP_
#define _SQUIRREL_CPP_

#include <windows.h>
#include "stdio.h"

#include "definition.h"
#include "version.h"
#include "lib.h"
#include "filefunc.h"
#include "netfunc.h"

#include "alphabet.h"
#include "./util/tree_work.h"
#include "sq_util.h"

/*
#define __HASH_TYPE			argv[1]
#define __HASH				argv[2]
#define __PASS_LENGTH		argv[3]
#define __ALPHABET_FILE		argv[4]
#define __IP_FILE			argv[5]
*/
bool client_mode=false;
int hash_type=0;
char* hash=NULL;
int pass_length=8;
char* alphabet_file=NULL;
char* ip_file=NULL;
ALPHABET alphabet;
TStoreHouse ex_clients;
int border_step=2;
bool victory=false;

char* __buf=NULL;
char* __seed=NULL;

//
// test:
//
// pass: qwerty
// md5 : d8578edf8458ce06fbc5bb76a58c5ca4
//

//
//
//
CLIENT myclient;

void usage()
{
		//
		// help message
		//
		printf("\n");
		printf("%s version %s\n\n",prog_name,version);
		printf("specially for distributed hash cracking.\n\n");
		printf("Usage:\n\n");
		printf("%s <-c> <-s: SEED><-ht:TYPE> <-hs:HASH> <-l:LENGTH> <-a:ALPHABET-FILE> <-ip:FILE>\n\n",prog_name);
		printf("       -c         client mode\n");
		printf("       -s: seed   pass for begin\n");
		printf("                  (default: first letter of alphabet)\n");
		printf("       -ht:int    hash type:\n");
		printf("                  (default: 0 = MD5)\n");
		printf("       -hs:hash   hash for crack\n");
		printf("       -l: int    max pass length\n");
		printf("                  (default: 8)\n");
		printf("       -a: file   file with alphabet for bruteforce\n");
		printf("                  (default: %s)\n",DEF_ALPHABET_FILE);
		printf("       -ip:file   file with IP-addresses on which client is running\n");
		printf("                  (default: %s)\n",IP_FILE_NAME);
		printf("\nJust for fun :) \t\t\t\t\t\t\t XIII\n");
}

void ValidateArgs(int argc, char **argv)
{
	//
	//
	// from HOD-icmp-attacks-poc.c: 2005-04-15: PUBLIC v.0.2 
	// Copyright (c) 2004-2005 houseofdabus.
	//
	int i;
	int ilen;

	for (i = 1; i < argc; i++) 
	{
		if ((argv[i][0] == '-') || (argv[i][0] == '/')) 
		{
			switch (tolower(argv[i][1])) {
				case 'h':
					switch (tolower(argv[i][2])) 
					{
						case 't':
							if (strlen(argv[i]) > 4)
								hash_type = atoi(&argv[i][4]);
							break;
						case 's':
							if (strlen(argv[i]) > 4)
							{
								ilen=strlen(&argv[i][4]);
								hash = new char [ilen+1];
								if(!hash)
								{
									prerr("Cant allocate memory for hash");
									return;
								}
								ZeroMemory(hash,ilen+1);
								lstrcpy(hash,&argv[i][4]);
							}
							break;
						default:
							usage();
							exit(1);
							break;
					}
					break;
				case 'i':
					switch (tolower(argv[i][2])) 
					{
						case 'p':
							if (strlen(argv[i]) > 4)
							{
								ilen=strlen(&argv[i][4]);
								ip_file = new char [ilen+1];
								if(!ip_file)
								{
									prerr("Cant allocate memory for IP file name");
									return;
								}
								ZeroMemory(ip_file,ilen+1);
								lstrcpy(ip_file,&argv[i][4]);
							}
							break;
						default:
							usage();
							exit(1);
							break;
					}
					break;
				case 'c':
					client_mode=true;
					break;
				case 's':
					if (strlen(argv[i]) > 3)
					{
						if(__seed)
						{
							delete []__seed;
							__seed=NULL;
						}
						ilen=strlen(&argv[i][2]);
						__seed=new char[ilen];
						if(!__seed)
						{
							prerr("Cant allocate memory for seed");
							return;
						}
						ZeroMemory(__seed,ilen);
						strcat(__seed,&argv[i][3]);
					}
					//printf("seed: %s\n",__seed);
					break;
				case 'l':
					if (strlen(argv[i]) > 3)
						pass_length = atoi(&argv[i][2]);
					//printf("length: %d\n",pass_length);
					break;
				case 'a':
					if (strlen(argv[i]) > 3)
					{
						ilen=strlen(&argv[i][3]);
						alphabet_file = new char [ilen+1];
						if(!alphabet_file)
						{
							prerr("Cant allocate memory for alphabet file name");
							return;
						}
						ZeroMemory(alphabet_file,ilen+1);
						lstrcpy(alphabet_file,&argv[i][3]);
						
					}
					break;
				default:
					usage();
					exit(1);
					break;
			}
		}
	}
	return;
}

int load_ip(char *file)
{
	//
	// load IP's from file
	//

	char buf[NEAR_SIZE_IP+1];
	HANDLE hFile;

	char *fbuf;
	fbuf = new char [FILE_BUF_SIZE];
	if(!fbuf)
		return 1;
	ZeroMemory(fbuf, FILE_BUF_SIZE);

	int count;

	CLIENT tcl;

	unsigned long int ireaded;
	hFile=CreateFile(file,GENERIC_READ,FILE_SHARE_READ|FILE_SHARE_WRITE,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_ARCHIVE,NULL);
	if(hFile==INVALID_HANDLE_VALUE)
	{
		prerr("CreateFile(%s,...)",file);
		if(fbuf)
			delete []fbuf;
		return 2;
	}

	ZeroMemory(buf, NEAR_SIZE_IP+1);
	count=0;
	do
	{
		ReadFile(hFile, fbuf, FILE_BUF_SIZE, &ireaded, NULL);
		if(ireaded==0)
			break;
		for(unsigned int i=0; i<ireaded; i++)
		{
			if(fbuf[i]=='\r' || fbuf[i]=='\n')
			{
				if(strlen(buf)>7) //## minimal IP ??
				{
					tcl.set_IP(buf);
					ex_clients.addNewElement(&tcl);
					writelog("+ IP:", tcl.get_IP());
					count=0;
					ZeroMemory(buf, NEAR_SIZE_IP+1);
				}
			}//if(fbuf[i]=='\r' || fbuf[i]=='\n')
			else
			{
				buf[count]=fbuf[i];
				count++;
			}
		}//for(unsigned int i=0; i<ireaded; i++)
	}
	while(ireaded>0);

	CloseHandle(hFile);
	if(fbuf)
		delete []fbuf;

	return 0;
}

int load_alphabet(char* file)
{
	//
	// load alphabet from file
	//

	if(!file)
		return 1;

	HANDLE hFile;
	char *fbuf;
	fbuf = new char [FILE_BUF_SIZE+1];
	if(!fbuf)
		return 1;
	ZeroMemory(fbuf, FILE_BUF_SIZE+1);

	unsigned long int ireaded;
	hFile=CreateFile(file,GENERIC_READ,FILE_SHARE_READ|FILE_SHARE_WRITE,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_ARCHIVE,NULL);
	if(hFile==INVALID_HANDLE_VALUE)
	{
		prerr("CreateFile(%s,...)",file);
		if(fbuf)
			delete []fbuf;
		return 2;
	}

	do
	{
		ReadFile(hFile, fbuf, FILE_BUF_SIZE, &ireaded, NULL);
		if(ireaded==0)
			break;
		if(alphabet.get_alphabet())
		{
			//
			//# lets suppose what alphabet length < FILE_BUF_SIZE
			//
			prerr("alphabet length must be less than FILE_BUF_SIZE",file);
			break;
		}
		else
		{
			alphabet.set_alphabet(fbuf);
			ZeroMemory(fbuf, FILE_BUF_SIZE+1);
		}
	}
	while(ireaded>0);

	CloseHandle(hFile);
	if(fbuf)
		delete []fbuf;

	return 0;
}

int save_distributed_data(char* file)
{
	//
	// save distributed data into file
	//
	if(!file)
		return 1;

	HANDLE hFile;
	char *fbuf;
	fbuf = new char [FILE_BUF_SIZE+1];
	if(!fbuf)
		return 1;
	ZeroMemory(fbuf, FILE_BUF_SIZE+1);

	unsigned long int iwrited;
	hFile=CreateFile(file,GENERIC_WRITE,FILE_SHARE_READ|FILE_SHARE_WRITE,NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_ARCHIVE,NULL);
	if(hFile==INVALID_HANDLE_VALUE)
	{
		prerr("CreateFile(%s,...)",file);
		if(fbuf)
			delete []fbuf;
		return 2;
	}
	char* ct;

	//
	// save pass length
	//
	itoa(pass_length,fbuf,10);
	WriteFile(hFile,fbuf,strlen(fbuf),&iwrited,NULL);
	WriteFile(hFile,"\n",1,&iwrited,NULL);
	ZeroMemory(fbuf, FILE_BUF_SIZE+1);

	//
	// save __buf
	//
	WriteFile(hFile,__buf,strlen(__buf),&iwrited,NULL);
	WriteFile(hFile,"\n",1,&iwrited,NULL);

	TStorage *pTemp=NULL;

	if(ex_clients.size()>0)
	{
		pTemp=ex_clients.storage;
		while(pTemp)
		{
			//--------------------------------------------------------
			// alphabet
			ct=pTemp->element.pcl->get_alphabet();
			WriteFile(hFile,ct,strlen(ct),&iwrited,NULL);
			WriteFile(hFile,"\n",1,&iwrited,NULL);
			// password
			ct=pTemp->element.pcl->get_password();
			WriteFile(hFile,ct,strlen(ct),&iwrited,NULL);
			WriteFile(hFile,"\n",1,&iwrited,NULL);
			// hash
			ct=pTemp->element.pcl->get_hash();
			WriteFile(hFile,ct,strlen(ct),&iwrited,NULL);
			WriteFile(hFile,"\n",1,&iwrited,NULL);
			// hash type
			itoa(pTemp->element.pcl->get_hash_type(),fbuf,10);
			WriteFile(hFile,fbuf,strlen(fbuf),&iwrited,NULL);
			WriteFile(hFile,"\n",1,&iwrited,NULL);
			ZeroMemory(fbuf, FILE_BUF_SIZE+1);
			// border
			ct=pTemp->element.pcl->get_border();
			WriteFile(hFile,ct,strlen(ct),&iwrited,NULL);
			WriteFile(hFile,"\n",1,&iwrited,NULL);
			//--------------------------------------------------------

			pTemp=pTemp->nextElement;
		}
	}
	else
		prerr("nothing to save :(");

	CloseHandle(hFile);
	if(fbuf)
		delete []fbuf;
	return 0;
}

int load_distributed_data(char* file)
{
	//
	// load distributed data from file
	//
	if(!file)
		return 1;
#if 0
	HANDLE hFile;
	char *fbuf;
	fbuf = new char [FILE_BUF_SIZE+1];
	if(!fbuf)
		return 1;
	ZeroMemory(fbuf, FILE_BUF_SIZE+1);

	unsigned long int iwrited;
	hFile=CreateFile(file,GENERIC_WRITE,FILE_SHARE_READ|FILE_SHARE_WRITE,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_ARCHIVE,NULL);
	if(hFile==INVALID_HANDLE_VALUE)
	{
		prerr("CreateFile(%s,...)",file);
		printf("[?] May be there no such file?\n");
		if(fbuf)
			delete []fbuf;
		return 2;
	}
	char* ct;

	//
	// load alphabet
	//
	ct=alphabet.get_alphabet();
	WriteFile(hFile,ct,strlen(ct),&iwrited,NULL);
	WriteFile(hFile,"\n",1,&iwrited,NULL);
	//
	// save pass length
	//
	itoa(pass_length,fbuf,10);
	WriteFile(hFile,fbuf,strlen(fbuf),&iwrited,NULL);
	WriteFile(hFile,"\n",1,&iwrited,NULL);
	ZeroMemory(fbuf, FILE_BUF_SIZE+1);
	//
	// save hash type
	//
	itoa(hash_type,fbuf,10);
	WriteFile(hFile,fbuf,strlen(fbuf),&iwrited,NULL);
	WriteFile(hFile,"\n",1,&iwrited,NULL);
	ZeroMemory(fbuf, FILE_BUF_SIZE+1);
	//
	// save __buf
	//
	WriteFile(hFile,__buf,strlen(__buf),&iwrited,NULL);
	WriteFile(hFile,"\n",1,&iwrited,NULL);


	TStorage *pTemp=NULL;

	if(ex_clients.size()>0)
	{
		pTemp=ex_clients.storage;
		while(pTemp)
		{
			//--------------------------------------------------------
			// alphabet
			//pTemp->element.pcl->set_alphabet(alphabet.get_alphabet());
			// password
			ct=pTemp->element.pcl->get_password();
			WriteFile(hFile,ct,strlen(ct),&iwrited,NULL);
			WriteFile(hFile,"\n",1,&iwrited,NULL);
			// hash
			ct=pTemp->element.pcl->get_hash();
			WriteFile(hFile,ct,strlen(ct),&iwrited,NULL);
			WriteFile(hFile,"\n",1,&iwrited,NULL);
			// hash type
			//pTemp->element.pcl->get_hash_type();
			// border
			ct=pTemp->element.pcl->get_border();
			WriteFile(hFile,ct,strlen(ct),&iwrited,NULL);
			WriteFile(hFile,"\n",1,&iwrited,NULL);
			//--------------------------------------------------------

			pTemp=pTemp->nextElement;
		}
	}
	else
		prerr("nothing to save :(");


	CloseHandle(hFile);
	if(fbuf)
		delete []fbuf;
#endif //#if 0
	return 0;
}

int main(int argc, char** argv)
{
	int i,ilen;
	char tc=0;
	HANDLE st;
	DWORD tid;
	//-
	double la;
	double n;
	int x;
	double di;
	double A;
	//-
	TStorage *pTemp=NULL;
	//
	// init random
	//
	xrand_init();

#ifdef WIN32
	wsa_init();
#endif //#ifdef WIN32

	if(argc<2)
	{
		usage();
		return 1;
	}

	printf("[ ] Start %s..\n",prog_name);
	writelog("program","[starting]");

	ValidateArgs(argc,argv);

	//
	// start client mode
	//
	if(start_serv_sock())
	{
		prerr("start_serv_sock()");
		goto Exit;
	}
#ifdef DEBUG
	if(MessageBox(NULL,"ServerThread",prog_name,MB_YESNO)==IDYES)
#endif // #ifdef DEBUG
		st=CreateThread(NULL,0,ServerThread,0,0,&tid);

	if(client_mode)
	{
		printf("[ ] client mode (press \"q\" for termination...)\n",prog_name);

		while(tc=getchar())
		{
			if(tc=='q' || tc=='Q')
			{
				printf("[ ] Terminating...\n",prog_name);
				net_freeze(1);
				writelog("program","[terminate]");
				goto Exit;
			}
		}
	}
	//
	// set default
	//
	hash_type=0; // md5
	if(!alphabet_file)
	{
		ilen=sizeof(DEF_ALPHABET_FILE);
		alphabet_file = new char [ilen+1];
		if(!alphabet_file)
		{
			prerr("Cant allocate memory for alphabet file name");
			return 1;
		}
		ZeroMemory(alphabet_file,ilen+1);
		lstrcpy(alphabet_file,DEF_ALPHABET_FILE);
	}
	if(!ip_file)
	{
		ilen=sizeof(IP_FILE_NAME);
		ip_file = new char [ilen+1];
		if(!ip_file)
		{
			prerr("Cant allocate memory for IP file name");
			return 1;
		}
		ZeroMemory(ip_file,ilen+1);
		lstrcpy(ip_file,IP_FILE_NAME);
	}

//------------------------------------------
#ifdef DEBUG
	printf("hash type  :   %d\n",hash_type);
	printf("hash       :   %s\n",hash);
	printf("pass length:   %d\n",pass_length);
	printf("alphabet   :   %s\n",alphabet_file);
	printf("ip         :   %s\n",ip_file);
#endif // #ifdef DEBUG

		writelog("hash",hash);
		writelog("alpha",alphabet_file);
		writelog("ip",ip_file);
//------------------------------------------

	//
	// read file with IP's
	//
	if(load_ip(ip_file))
	{
		prerr("read IP's from %s",ip_file);
	}

	//
	// load alphabet
	//
	if(load_alphabet(alphabet_file))
	{
		prerr("read alphabet from %s",alphabet_file);
	}
//-------------------
#ifdef DEBUG
	tc=(alphabet.get_alphabet())[0];
	printf("alphabet:\n");
	do
	{
		printf("%c",tc);
		tc = alphabet.get_next_symbol(tc);
	}
	while(tc!=1);
	printf("\n\n");
#endif // #ifdef DEBUG
//-------------------

#ifdef DEBUG
	/**
	myclient.set_alphabet("ab");//alphabet.get_alphabet());
	myclient.set_hash("44d88612fea8a8f36de82e1278abb02f");
	myclient.set_hash_type(0);
	myclient.set_IP(LOOPBACK_IP);
	myclient.set_password("a");
	myclient.set_border("abb");
	myclient.crack();
	/**/
#endif // #ifdef DEBUG

	printf("[ ] server mode (press \"q\" for termination...)\n\n",prog_name);

	//
	// appoint borders
	//
	//-----------------------------------------
	//
	// 1. calculate number of Arrangements:
	//
	//   _ k     n!
	//  |_|  = _____
	//  | |n   (n-k)!
	// 
	//
	ilen = alphabet.length();
	n=factorial(ilen);
	A = n/(factorial(ilen-pass_length));

	printf("[ ] Arrangement number: %e\n",A);

	//-----------------------------------------
	//
	// 2. get borders step
	//
	//
	la=n/ITERATION_NUMBER;
	i = ilen; // alphabet.length();
	di=n;
	while(1)
	{
		di/=i;
		if(di>la)
			i--;
		else
			break;
	}
	x = ilen -i+1;		// x will contain borders step
	//-----------------------------------------
	//
	// 3. set borders
	//
	//
	border_step=x;

	__buf = new char [pass_length+2];
	if(!__buf)
	{
		prerr("cant allocate memory for buffer in main()");
		goto Exit;
	}
	ZeroMemory(__buf,pass_length+2);

#ifdef DEBUG
	/**
	pass_length=4;
	
	buf[0]='}';//(alphabet.get_alphabet())[0];
	buf[1]='}';//(alphabet.get_alphabet())[0];
	buf[2]='}';//(alphabet.get_alphabet())[0];
	buf[3]='}';//(alphabet.get_alphabet())[2];
	printf("buf: %s\n",buf);
	if(next_border(buf))
	{
		printf("buf: %s\n",buf);
		if(!strcmp(buf,""))
		{
			printf("Its last!\n");
		}
	}
	else
		prerr(":(");
	/**/
#endif // #ifdef DEBUG

	//
	// set first borders
	//
	if(__seed)
		strcat(__buf,__seed);
	else
		__buf[0]=(alphabet.get_alphabet())[0];

	//
	// add own IP
	//
	myclient.set_IP(LOOPBACK_IP);
	ex_clients.addNewElement(&myclient);

	if(ex_clients.size()>0)
	{
		pTemp=ex_clients.storage;
		while(pTemp)
		{
			//--------------------------------------------------------
			// alphabet
			pTemp->element.pcl->set_alphabet(alphabet.get_alphabet());
			// password
			//pTemp->element.pcl->set_password(__buf);
			// hash
			pTemp->element.pcl->set_hash(hash);
			// hash type
			pTemp->element.pcl->set_hash_type(hash_type);
			//
			// get next border
			//
			/*
			if(next_border(__buf))
			{
				if(!strcmp(__buf,""))
				{
					printf("Its last!\n");
					break;
				}
			}
			*/
			// border
			//pTemp->element.pcl->set_border(__buf);
			//--------------------------------------------------------

			pTemp=pTemp->nextElement;
		}
	}
	else
		prerr("here no external IP's :(");

	//
	// start server mode
	//
#ifdef DEBUG
	if(MessageBox(NULL,"FindAnotherServer",prog_name,MB_YESNO)==IDYES)
#endif // #ifdef DEBUG
		st=CreateThread(NULL,0,FindAnotherServer,0,0,&tid);

	while(tc=getchar())
	{
		if(tc=='q' || tc=='Q')
		{
			printf("[ ] Terminating...\n",prog_name);
			net_freeze(1);
			Sleep(2000);
			writelog("program","[terminate]");
			goto Exit;
		}
	}

Exit:

#ifdef WIN32
	wsa_end();
#endif //#ifdef WIN32

	if(hash)
		delete []hash;
	if(alphabet_file)
		delete []alphabet_file;
	if(ip_file)
		delete []ip_file;
	if(__buf)
		delete []__buf;
	if(__seed)
		delete []__seed;

	return 0;
}


#endif // #ifndef _SQUIRREL_CPP_